
/*
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */


#ifndef ShiftRegister_h
#define ShiftRegister_h
#include <inttypes.h>

class ShiftRegister
{

public:
	// Initialize the shift registers
	ShiftRegister( uint8_t SER_pin , uint8_t RCLK_pin , uint8_t SRCLK_pin , uint8_t number_of_outputs ); 
	// Sets all the outputs to LOW
	// Needs writeRegisters() to apply changes
	void initRegisters(uint8_t value); 
	// Sets a specific output to high or low
	// Needs writeRegisters() to apply changes
	void setRegister( uint8_t pin_number, uint8_t value);
	// Updates the values of all the registers
	void writeRegisters();
//	void writeRegistersDebug();
	// Sets a specific output to high or low
	// Changes apply immediatly, does not need writeRegisters()
	void setRegisterNow( uint8_t pin_number, uint8_t value);

  
protected:
	uint8_t SER_pin;
	uint8_t RCLK_pin;
	uint8_t SRCLK_pin;	
	uint8_t number_of_outputs;
	uint8_t* registers;
};

#endif
